# Summary

* [Guide](/guide.md)
    * [Tutorial](/tutorial.md)
    * [Syntax](/syntax/main.md)
        * [Data Binding](/syntax/data-binding.md)
        * [Style and Class](/syntax/style-n-class.md)
        * [Events](/syntax/events.md)
        * [Display Logic Control](/syntax/display-logic.md)
        * [Render Logic Control](/syntax/render-logic.md)
        * [Composed Component](/syntax/composed-component.md)
        * [Find an Element](/syntax/id.md)
        * [Communications](/syntax/comm.md)
        * [Page Config & Data](/syntax/config-n-data.md)
    * [How-tos](/how-to/main.md)
        * [Require 3rd-party Libs](/how-to/require-3rd-party-libs.md)
        * [Transform Code Into JS Bundle](/how-to/transform-code-into-js-bundle.md)
    * [Advanced](/advanced/main.md)
        * [How It Works](/advanced/how-it-works.md)
        * [How Data Binding Works](/advanced/how-data-binding-works.md)
        * [Integrate to Android](/advanced/integrate-to-android.md)
        * [Extend to Android](/advanced/extend-to-android.md)
        * [Integrate to HTML5](/advanced/integrate-to-html5.md)
        * [Extend to HTML5](/advanced/extend-to-html5.md)
* [References](/references/main.md)
    * [Bootstrap](/references/bootstrap.md)
    * [Component Definition](/references/component-defs.md)
    * [Instance APIs](/references/api.md)
    * [Built-in Components](/components/main.md)
        * [Common Attributes](/references/common-attrs.md)
        * [Common Style](/references/common-style.md)
            * [Text Style](/references/text-style.md)
        * [Common Event](/references/common-event.md)
        * [Special Element](/components/special-element.md)
        * [&lt;div&gt;](/components/div.md)
        * [&lt;scroller&gt;](/components/scroller.md)
        * [&lt;list&gt;](/components/list.md)
            * [&lt;cell&gt;](/components/cell.md)
        * [&lt;text&gt;](/components/text.md)
        * [&lt;image&gt;](/components/image.md)
        * [&lt;input&gt;](/components/input.md)
        * [&lt;switch&gt;](/components/switch.md)
        * [&lt;slider&gt;](/components/slider.md)
            * [&lt;indicator&gt;](/components/indicator.md)
        * [&lt;video&gt;](/components/video.md)
        * [&lt;a&gt;](/components/a.md)
        * [&lt;web&gt;](/components/web.md)
        * [&lt;wxc-tabbar&gt;](/components/wxc-tabbar.md)
    * [Built-in Modules](/modules/README.md)
        * [dom](/modules/dom.md)
        * [steam](/modules/stream.md)
        * [modal](/modules/modal.md)
        * [animation](/modules/animation.md)
        * [webview](/modules/webview.md)
    * Low-level Specs
        * [JS Bundle Format](/specs/js-bundle-format.md)
        * [JS Framework APIs](/specs/js-framework-apis.md)
        * [Virtual DOM APIs](/specs/virtual-dom-apis.md)
* [Examples](demo/main.md)
    * [Hello World](demo/hello-world.md)
    * [Modal](demo/modal.md)
    * [List](demo/list.md)
    * [Slider](demo/slider.md)
    * [Animation](demo/animation.md)
    * [More](https://github.com/alibaba/weex/tree/dev/examples)

* [Service & Tools](/tools/main.md)
    * [CLI](/tools/cli.md)
    * [Transformer](/tools/transformer.md)
    * [Playground App](/tools/playground-app.md)

* [FAQ](/faq.md)

