# Transform Code into Js Bundle

Paragraphs [Maintain Your Component Code](./maintain-your-component-code.md), [Maintain Your Component Code](./maintain-your-component-code.md) and [Require 3rd Party Libs](./require-3rd-party-libs.md) show us how to write and organize weex code. However, Weex DSL code must be transformed to `js bundle` so that `js framework` can parse and execute it for iOS, Android and HTML5 portal. For more information, please refer to [How It Works
](/advanced/how-it-works.md) and [JS Bundle Format](../specs/js-bundle-format.md).

Now come back to the topic `transform code into js bundle`. There are several ways to achieve the goal.

## transformer

```bash
tnpm install weex-transformer
```

### CLI Tool

```
  Usage: transformer [options] <file...>

  Options:

    -h, --help               output usage information
    -V, --version            output the version number
    -l, --oldFormat [value]  whether to transform to old format (default: false)
    -e, --isEntry [value]    whether is an entry module which has `bootstrap` (default: true)
    -o, --output [path]      the output file dirname
```

### API

** transform(name, code, path, elements, config) **

```javascript
var transformer = require('weex-transformer')
var output = transformer.transform('foo', '/* code here */', '.', {})
```

params:

- `name`: string, current bundle name
- `code`: string, source code
- `path`: string *optional*, useful when find custom component in a certain path
- `elements`: object *optional*, existed custom component map
- `config`: object *optional*
    * `oldFormat`: whether to transform to old format (default: false)
    * `isEntry`: whether is an entry module which has `bootstrap` (default: true)

returns:

- an object with keys
    * `result`: string, all custom components `define()` and final `bootstrap()`
    * `logs`: array, corresponding warning & error logs

## gulp weex

```bash
tnpm install gulp-weex
```

```javascript
var gulp = require('gulp')
var weex = require('gulp-weex')

gulp.task('default', function () {
  return gulp.src('src/*.html')
    .pipe(weex({}))
    .pipe(gulp.dest('./dest'))
})
```

Options:

- `oldFormat`: whether to transform to old format (default: false)
- `isEntry`: whether is an entry module which has `bootstrap` (default: true)
